Loading...
Searching...
No Matches
Opm::SatfuncConsistencyChecks< Scalar >::Check Class Referenceabstract

Call-back interface for an individual check. More...

`#include <SatfuncConsistencyChecks.hpp>`

Inheritance diagram for Opm::SatfuncConsistencyChecks< Scalar >::Check:

## Public Member Functions

virtual | ~Check ()=default
| Virtual destructor since class has virtual functions.
virtual void | test (const EclEpsScalingPointsInfo< Scalar > &endPoints)=0
| Run specific check against a set of saturation function end-points.
virtual bool | isViolated () const =0
| Whether or not last set of end-points violated this particular check.
virtual bool | isCritical () const =0
| Whether or not this check is critical to the simulator's ability to run the case.
virtual std::size_t | numExportedCheckValues () const =0
| Number of `Scalar` values involved in the check.
virtual void | exportCheckValues (Scalar *exportedCheckValues) const =0
| Get a linearised copy of the `Scalar` values involved in the check.
virtual std::string | description () const =0
| Descriptive textual summary of this check.
virtual std::string | condition () const =0
| Textual representation of the consistency condition.
virtual void | columnNames (std::string *headers) const =0
| Retrieve names of the exported check values.

## Detailed Description

template<typename Scalar>
class Opm::SatfuncConsistencyChecks< Scalar >::Check

Call-back interface for an individual check.

Specific checks are expected to inherit from this base class.

## Member Function Documentation

## columnNames()

template<typename Scalar>

virtual void Opm::SatfuncConsistencyChecks< Scalar >::Check::columnNames | ( | std::string * | headers | ) | const

pure virtual

Retrieve names of the exported check values.

Order should match that of exportCheckValues().

Parameters

  [in,out] | headers | Pointer to contiguous sequence of at least numExportedCheckValues() strings. It is the responsibility of columnNames() to populate this sequence with sensible values.

Implemented in Opm::Satfunc::PhaseChecks::Gas::SGcr< Scalar >, Opm::Satfunc::PhaseChecks::Gas::SGmax< Scalar >, Opm::Satfunc::PhaseChecks::Gas::SGmin< Scalar >, Opm::Satfunc::PhaseChecks::Oil::MobileOil_GO_SGcr< Scalar >, Opm::Satfunc::PhaseChecks::Oil::MobileOil_GO_SGmin< Scalar >, Opm::Satfunc::PhaseChecks::Oil::MobileOil_OW_SWcr< Scalar >, Opm::Satfunc::PhaseChecks::Oil::MobileOil_OW_SWmin< Scalar >, Opm::Satfunc::PhaseChecks::Oil::SOcr_GO< Scalar >, Opm::Satfunc::PhaseChecks::Oil::SOcr_OW< Scalar >, Opm::Satfunc::PhaseChecks::Oil::SOmin_GO< Scalar >, Opm::Satfunc::PhaseChecks::Oil::SOmin_OW< Scalar >, Opm::Satfunc::PhaseChecks::ThreePointHorizontal::DisplacingOil_GO< Scalar >, Opm::Satfunc::PhaseChecks::ThreePointHorizontal::DisplacingOil_OW< Scalar >, Opm::Satfunc::PhaseChecks::Water::SWcr< Scalar >, Opm::Satfunc::PhaseChecks::Water::SWmax< Scalar >, and Opm::Satfunc::PhaseChecks::Water::SWmin< Scalar >.

## condition()

template<typename Scalar>

virtual std::string Opm::SatfuncConsistencyChecks< Scalar >::Check::condition | ( |  | ) | const

pure virtual

Textual representation of the consistency condition.

Implemented in Opm::Satfunc::PhaseChecks::Gas::SGcr< Scalar >, Opm::Satfunc::PhaseChecks::Gas::SGmax< Scalar >, Opm::Satfunc::PhaseChecks::Gas::SGmin< Scalar >, Opm::Satfunc::PhaseChecks::Oil::MobileOil_GO_SGcr< Scalar >, Opm::Satfunc::PhaseChecks::Oil::MobileOil_GO_SGmin< Scalar >, Opm::Satfunc::PhaseChecks::Oil::MobileOil_OW_SWcr< Scalar >, Opm::Satfunc::PhaseChecks::Oil::MobileOil_OW_SWmin< Scalar >, Opm::Satfunc::PhaseChecks::Oil::SOcr_GO< Scalar >, Opm::Satfunc::PhaseChecks::Oil::SOcr_OW< Scalar >, Opm::Satfunc::PhaseChecks::Oil::SOmin_GO< Scalar >, Opm::Satfunc::PhaseChecks::Oil::SOmin_OW< Scalar >, Opm::Satfunc::PhaseChecks::ThreePointHorizontal::DisplacingOil_GO< Scalar >, Opm::Satfunc::PhaseChecks::ThreePointHorizontal::DisplacingOil_OW< Scalar >, Opm::Satfunc::PhaseChecks::Water::SWcr< Scalar >, Opm::Satfunc::PhaseChecks::Water::SWmax< Scalar >, and Opm::Satfunc::PhaseChecks::Water::SWmin< Scalar >.

## description()

template<typename Scalar>

virtual std::string Opm::SatfuncConsistencyChecks< Scalar >::Check::description | ( |  | ) | const

pure virtual

Descriptive textual summary of this check.

Might for instance be something along the lines of Oil-phase scaled end-points

Implemented in Opm::Satfunc::PhaseChecks::Gas::SGcr< Scalar >, Opm::Satfunc::PhaseChecks::Gas::SGmax< Scalar >, Opm::Satfunc::PhaseChecks::Gas::SGmin< Scalar >, Opm::Satfunc::PhaseChecks::Oil::MobileOil_GO_SGcr< Scalar >, Opm::Satfunc::PhaseChecks::Oil::MobileOil_GO_SGmin< Scalar >, Opm::Satfunc::PhaseChecks::Oil::MobileOil_OW_SWcr< Scalar >, Opm::Satfunc::PhaseChecks::Oil::MobileOil_OW_SWmin< Scalar >, Opm::Satfunc::PhaseChecks::Oil::SOcr_GO< Scalar >, Opm::Satfunc::PhaseChecks::Oil::SOcr_OW< Scalar >, Opm::Satfunc::PhaseChecks::Oil::SOmin_GO< Scalar >, Opm::Satfunc::PhaseChecks::Oil::SOmin_OW< Scalar >, Opm::Satfunc::PhaseChecks::ThreePointHorizontal::DisplacingOil_GO< Scalar >, Opm::Satfunc::PhaseChecks::ThreePointHorizontal::DisplacingOil_OW< Scalar >, Opm::Satfunc::PhaseChecks::Water::SWcr< Scalar >, Opm::Satfunc::PhaseChecks::Water::SWmax< Scalar >, and Opm::Satfunc::PhaseChecks::Water::SWmin< Scalar >.

## exportCheckValues()

template<typename Scalar>

virtual void Opm::SatfuncConsistencyChecks< Scalar >::Check::exportCheckValues | ( | Scalar * | exportedCheckValues | ) | const

pure virtual

Get a linearised copy of the `Scalar` values involved in the check.

Parameters

  [in,out] | exportedCheckValues | Pointer to contiguous sequence of at least numExportedCheckValues() `Scalars`. It is the responsibility of exportCheckValues() to populate this sequence with sensible values.

Implemented in Opm::Satfunc::PhaseChecks::Gas::SGcr< Scalar >, Opm::Satfunc::PhaseChecks::Gas::SGmax< Scalar >, Opm::Satfunc::PhaseChecks::Gas::SGmin< Scalar >, Opm::Satfunc::PhaseChecks::Oil::MobileOil_GO_SGcr< Scalar >, Opm::Satfunc::PhaseChecks::Oil::MobileOil_GO_SGmin< Scalar >, Opm::Satfunc::PhaseChecks::Oil::MobileOil_OW_SWcr< Scalar >, Opm::Satfunc::PhaseChecks::Oil::MobileOil_OW_SWmin< Scalar >, Opm::Satfunc::PhaseChecks::Oil::SOcr_GO< Scalar >, Opm::Satfunc::PhaseChecks::Oil::SOcr_OW< Scalar >, Opm::Satfunc::PhaseChecks::Oil::SOmin_GO< Scalar >, Opm::Satfunc::PhaseChecks::Oil::SOmin_OW< Scalar >, Opm::Satfunc::PhaseChecks::ThreePointHorizontal::DisplacingOil_GO< Scalar >, Opm::Satfunc::PhaseChecks::ThreePointHorizontal::DisplacingOil_OW< Scalar >, Opm::Satfunc::PhaseChecks::Water::SWcr< Scalar >, Opm::Satfunc::PhaseChecks::Water::SWmax< Scalar >, and Opm::Satfunc::PhaseChecks::Water::SWmin< Scalar >.

## isCritical()

template<typename Scalar>

virtual bool Opm::SatfuncConsistencyChecks< Scalar >::Check::isCritical | ( |  | ) | const

pure virtual

Whether or not this check is critical to the simulator's ability to run the case.

Violating critical checks should typically stop the run.

Implemented in Opm::Satfunc::PhaseChecks::PhaseCheckBase< Scalar >.

## isViolated()

template<typename Scalar>

virtual bool Opm::SatfuncConsistencyChecks< Scalar >::Check::isViolated | ( |  | ) | const

pure virtual

Whether or not last set of end-points violated this particular check.

Implemented in Opm::Satfunc::PhaseChecks::PhaseCheckBase< Scalar >.

## numExportedCheckValues()

template<typename Scalar>

virtual std::size_t Opm::SatfuncConsistencyChecks< Scalar >::Check::numExportedCheckValues | ( |  | ) | const

pure virtual

Number of `Scalar` values involved in the check.

Implemented in Opm::Satfunc::PhaseChecks::Gas::SGcr< Scalar >, Opm::Satfunc::PhaseChecks::Gas::SGmax< Scalar >, Opm::Satfunc::PhaseChecks::Gas::SGmin< Scalar >, Opm::Satfunc::PhaseChecks::Oil::MobileOil_GO_SGcr< Scalar >, Opm::Satfunc::PhaseChecks::Oil::MobileOil_GO_SGmin< Scalar >, Opm::Satfunc::PhaseChecks::Oil::MobileOil_OW_SWcr< Scalar >, Opm::Satfunc::PhaseChecks::Oil::MobileOil_OW_SWmin< Scalar >, Opm::Satfunc::PhaseChecks::Oil::SOcr_GO< Scalar >, Opm::Satfunc::PhaseChecks::Oil::SOcr_OW< Scalar >, Opm::Satfunc::PhaseChecks::Oil::SOmin_GO< Scalar >, Opm::Satfunc::PhaseChecks::Oil::SOmin_OW< Scalar >, Opm::Satfunc::PhaseChecks::ThreePointHorizontal::DisplacingOil_GO< Scalar >, Opm::Satfunc::PhaseChecks::ThreePointHorizontal::DisplacingOil_OW< Scalar >, Opm::Satfunc::PhaseChecks::Water::SWcr< Scalar >, Opm::Satfunc::PhaseChecks::Water::SWmax< Scalar >, and Opm::Satfunc::PhaseChecks::Water::SWmin< Scalar >.

## test()

template<typename Scalar>

virtual void Opm::SatfuncConsistencyChecks< Scalar >::Check::test | ( | const EclEpsScalingPointsInfo< Scalar > & | endPoints | ) |

pure virtual

Run specific check against a set of saturation function end-points.

Parameters

  [in] | endPoints | Set of saturation function end-points. Might for instance be the scaled end-points of the drainage functions in a single grid block or the unscaled end-points of the tabulated saturation functions in a single saturation region.

Implemented in Opm::Satfunc::PhaseChecks::PhaseCheckBase< Scalar >.

The documentation for this class was generated from the following file:

- opm/simulators/utils/satfunc/SatfuncConsistencyChecks.hpp